=== debian/changelog ===
direwolf (1.8~beta1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.8~beta1+dfsg
    - Closes: #1112845
  * Refresh d/patches
    - Remove lib-udev-rules and desktop-main-category as they are
    upstreamed
  * d/copyright refresh
  * d/watch update to v5

 -- Dave Hibberd <hibby@debian.org>  Thu, 16 Oct 2025 00:11:53 +0100
