=== debian/watch ===
Version: 5
Template: Github
Owner: wb2osz
Project: direwolf
Dversion-Mangle: s/\+dfsg\d*$//
